Package org.jfree.layouting.renderer.model

## Interface BoxDefinition

- All Known Implementing Classes:
    `DefaultBoxDefinition`, `EmptyBoxDefinition`

      public interface BoxDefinition

  A box definition. Todo How to deal with auto-size margins?
  Author:
    Thomas Morgner

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CSSColorValue` | `getBackgroundColor​()` |
    `Border` | `getBorder​()` |
    `RenderLength` | `getMarginBottom​()` |
    `RenderLength` | `getMarginLeft​()` |
    `RenderLength` | `getMarginRight​()` |
    `RenderLength` | `getMarginTop​()` |
    `RenderLength` | `getMaximumHeight​()` |
    `RenderLength` | `getMaximumWidth​()` |
    `RenderLength` | `getMinimumHeight​()` |
    `RenderLength` | `getMinimumWidth​()` |
    `RenderLength` | `getPaddingBottom​()` |
    `RenderLength` | `getPaddingLeft​()` |
    `RenderLength` | `getPaddingRight​()` |
    `RenderLength` | `getPaddingTop​()` |
    `RenderLength` | `getPreferredHeight​()` | The preferred size is only set, if a height has been explicitly defined.
    `RenderLength` | `getPreferredWidth​()` | The preferred size is only set, if a width has been explicitly defined.
    `boolean` | `isEmpty​()` |
    `BoxDefinition[]` | `split​(int axis)` |

- - ### Method Detail

    - #### getMarginTop

          RenderLength getMarginTop​()

    - #### getMarginBottom

          RenderLength getMarginBottom​()

    - #### getMarginLeft

          RenderLength getMarginLeft​()

    - #### getMarginRight

          RenderLength getMarginRight​()

    - #### getPaddingTop

          RenderLength getPaddingTop​()

    - #### getPaddingLeft

          RenderLength getPaddingLeft​()

    - #### getPaddingBottom

          RenderLength getPaddingBottom​()

    - #### getPaddingRight

          RenderLength getPaddingRight​()

    - #### getBorder

          Border getBorder​()

    - #### getMinimumWidth

          RenderLength getMinimumWidth​()

    - #### getMinimumHeight

          RenderLength getMinimumHeight​()

    - #### getMaximumWidth

          RenderLength getMaximumWidth​()

    - #### getMaximumHeight

          RenderLength getMaximumHeight​()

    - #### getPreferredWidth

          RenderLength getPreferredWidth​()

      The preferred size is only set, if a width has been explicitly defined.
      Returns:

    - #### getPreferredHeight

          RenderLength getPreferredHeight​()

      The preferred size is only set, if a height has been explicitly defined.
      Returns:

    - #### split

          BoxDefinition[] split​(int axis)

    - #### getBackgroundColor

          CSSColorValue getBackgroundColor​()

    - #### isEmpty

          boolean isEmpty​()